Documentation: Add create-ignore to git svn manual
[git/dscho.git] / git-am.sh
blob75886a8f2fb0c2244ba921398ae2339dc9ffea26
1 #!/bin/sh
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git-am [options] <mbox>|<Maildir>...
9 git-am [options] --resolved
10 git-am [options] --skip
12 d,dotest= (removed -- do not use)
13 i,interactive run interactively
14 b,binary pass --allo-binary-replacement to git-apply
15 3,3way allow fall back on 3way merging if needed
16 s,signoff add a Signed-off-by line to the commit message
17 u,utf8 recode into utf8 (default)
18 k,keep pass -k flag to git-mailinfo
19 whitespace= pass it through git-apply
20 C= pass it through git-apply
21 p= pass it through git-apply
22 resolvemsg= override error message when patch failure occurs
23 r,resolved to be used after a patch failure
24 skip skip the current patch
25 rebasing (internal use for git-rebase)"
27 . git-sh-setup
28 prefix=$(git rev-parse --show-prefix)
29 set_reflog_action am
30 require_work_tree
31 cd_to_toplevel
33 git var GIT_COMMITTER_IDENT >/dev/null || exit
35 stop_here () {
36 echo "$1" >"$dotest/next"
37 exit 1
40 stop_here_user_resolve () {
41 if [ -n "$resolvemsg" ]; then
42 printf '%s\n' "$resolvemsg"
43 stop_here $1
45 cmdline=$(basename $0)
46 if test '' != "$interactive"
47 then
48 cmdline="$cmdline -i"
50 if test '' != "$threeway"
51 then
52 cmdline="$cmdline -3"
54 echo "When you have resolved this problem run \"$cmdline --resolved\"."
55 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
57 stop_here $1
60 go_next () {
61 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
62 "$dotest/patch" "$dotest/info"
63 echo "$next" >"$dotest/next"
64 this=$next
67 cannot_fallback () {
68 echo "$1"
69 echo "Cannot fall back to three-way merge."
70 exit 1
73 fall_back_3way () {
74 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
76 rm -fr "$dotest"/patch-merge-*
77 mkdir "$dotest/patch-merge-tmp-dir"
79 # First see if the patch records the index info that we can use.
80 git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
81 "$dotest/patch" &&
82 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
83 git write-tree >"$dotest/patch-merge-base+" ||
84 cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
86 echo Using index info to reconstruct a base tree...
87 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
88 git apply $binary --cached <"$dotest/patch"
89 then
90 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
91 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
92 else
93 cannot_fallback "Did you hand edit your patch?
94 It does not apply to blobs recorded in its index."
97 test -f "$dotest/patch-merge-index" &&
98 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
99 orig_tree=$(cat "$dotest/patch-merge-base") &&
100 rm -fr "$dotest"/patch-merge-* || exit 1
102 echo Falling back to patching base and 3-way merge...
104 # This is not so wrong. Depending on which base we picked,
105 # orig_tree may be wildly different from ours, but his_tree
106 # has the same set of wildly different changes in parts the
107 # patch did not touch, so recursive ends up canceling them,
108 # saying that we reverted all those changes.
110 eval GITHEAD_$his_tree='"$FIRSTLINE"'
111 export GITHEAD_$his_tree
112 git-merge-recursive $orig_tree -- HEAD $his_tree || {
113 git rerere
114 echo Failed to merge in the changes.
115 exit 1
117 unset GITHEAD_$his_tree
120 prec=4
121 dotest=".dotest"
122 sign= utf8=t keep= skip= interactive= resolved= binary= rebasing=
123 resolvemsg= resume=
124 git_apply_opt=
126 while test $# != 0
128 case "$1" in
129 -i|--interactive)
130 interactive=t ;;
131 -b|--binary)
132 binary=t ;;
133 -3|--3way)
134 threeway=t ;;
135 -s|--signoff)
136 sign=t ;;
137 -u|--utf8)
138 utf8=t ;; # this is now default
139 --no-utf8)
140 utf8= ;;
141 -k|--keep)
142 keep=t ;;
143 -r|--resolved)
144 resolved=t ;;
145 --skip)
146 skip=t ;;
147 --rebasing)
148 rebasing=t threeway=t keep=t binary=t ;;
149 -d|--dotest)
150 die "-d option is no longer supported. Do not use."
152 --resolvemsg)
153 shift; resolvemsg=$1 ;;
154 --whitespace)
155 git_apply_opt="$git_apply_opt $1=$2"; shift ;;
156 -C|-p)
157 git_apply_opt="$git_apply_opt $1$2"; shift ;;
159 shift; break ;;
161 usage ;;
162 esac
163 shift
164 done
166 # If the dotest directory exists, but we have finished applying all the
167 # patches in them, clear it out.
168 if test -d "$dotest" &&
169 last=$(cat "$dotest/last") &&
170 next=$(cat "$dotest/next") &&
171 test $# != 0 &&
172 test "$next" -gt "$last"
173 then
174 rm -fr "$dotest"
177 if test -d "$dotest"
178 then
179 case "$#,$skip$resolved" in
180 0,*t*)
181 # Explicit resume command and we do not have file, so
182 # we are happy.
183 : ;;
185 # No file input but without resume parameters; catch
186 # user error to feed us a patch from standard input
187 # when there is already $dotest. This is somewhat
188 # unreliable -- stdin could be /dev/null for example
189 # and the caller did not intend to feed us a patch but
190 # wanted to continue unattended.
191 tty -s
194 false
196 esac ||
197 die "previous dotest directory $dotest still exists but mbox given."
198 resume=yes
199 else
200 # Make sure we are not given --skip nor --resolved
201 test ",$skip,$resolved," = ,,, ||
202 die "Resolve operation not in progress, we are not resuming."
204 # Start afresh.
205 mkdir -p "$dotest" || exit
207 if test -n "$prefix" && test $# != 0
208 then
209 first=t
210 for arg
212 test -n "$first" && {
213 set x
214 first=
216 case "$arg" in
218 set "$@" "$arg" ;;
220 set "$@" "$prefix$arg" ;;
221 esac
222 done
223 shift
225 git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" || {
226 rm -fr "$dotest"
227 exit 1
230 # -b, -s, -u, -k and --whitespace flags are kept for the
231 # resuming session after a patch failure.
232 # -3 and -i can and must be given when resuming.
233 echo "$binary" >"$dotest/binary"
234 echo " $ws" >"$dotest/whitespace"
235 echo "$sign" >"$dotest/sign"
236 echo "$utf8" >"$dotest/utf8"
237 echo "$keep" >"$dotest/keep"
238 echo 1 >"$dotest/next"
239 if test -n "$rebasing"
240 then
241 : >"$dotest/rebasing"
242 else
243 : >"$dotest/applying"
247 case "$resolved" in
249 files=$(git diff-index --cached --name-only HEAD --) || exit
250 if [ "$files" ]; then
251 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
252 exit 1
254 esac
256 if test "$(cat "$dotest/binary")" = t
257 then
258 binary=--allow-binary-replacement
260 if test "$(cat "$dotest/utf8")" = t
261 then
262 utf8=-u
263 else
264 utf8=-n
266 if test "$(cat "$dotest/keep")" = t
267 then
268 keep=-k
270 ws=`cat "$dotest/whitespace"`
271 if test "$(cat "$dotest/sign")" = t
272 then
273 SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
274 s/>.*/>/
275 s/^/Signed-off-by: /'
277 else
278 SIGNOFF=
281 last=`cat "$dotest/last"`
282 this=`cat "$dotest/next"`
283 if test "$skip" = t
284 then
285 git rerere clear
286 this=`expr "$this" + 1`
287 resume=
290 if test "$this" -gt "$last"
291 then
292 echo Nothing to do.
293 rm -fr "$dotest"
294 exit
297 while test "$this" -le "$last"
299 msgnum=`printf "%0${prec}d" $this`
300 next=`expr "$this" + 1`
301 test -f "$dotest/$msgnum" || {
302 resume=
303 go_next
304 continue
307 # If we are not resuming, parse and extract the patch information
308 # into separate files:
309 # - info records the authorship and title
310 # - msg is the rest of commit log message
311 # - patch is the patch body.
313 # When we are resuming, these files are either already prepared
314 # by the user, or the user can tell us to do so by --resolved flag.
315 case "$resume" in
317 git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
318 <"$dotest/$msgnum" >"$dotest/info" ||
319 stop_here $this
321 # skip pine's internal folder data
322 grep '^Author: Mail System Internal Data$' \
323 <"$dotest"/info >/dev/null &&
324 go_next && continue
326 test -s $dotest/patch || {
327 echo "Patch is empty. Was it split wrong?"
328 stop_here $this
330 if test -f "$dotest/rebasing" &&
331 commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
332 -e q "$dotest/$msgnum") &&
333 test "$(git cat-file -t "$commit")" = commit
334 then
335 git cat-file commit "$commit" |
336 sed -e '1,/^$/d' >"$dotest/msg-clean"
337 else
338 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
339 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
341 (printf '%s\n\n' "$SUBJECT"; cat "$dotest/msg") |
342 git stripspace > "$dotest/msg-clean"
345 esac
347 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
348 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
349 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
351 if test -z "$GIT_AUTHOR_EMAIL"
352 then
353 echo "Patch does not have a valid e-mail address."
354 stop_here $this
357 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
359 case "$resume" in
361 if test '' != "$SIGNOFF"
362 then
363 LAST_SIGNED_OFF_BY=`
364 sed -ne '/^Signed-off-by: /p' \
365 "$dotest/msg-clean" |
366 sed -ne '$p'
368 ADD_SIGNOFF=`
369 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
370 test '' = "$LAST_SIGNED_OFF_BY" && echo
371 echo "$SIGNOFF"
373 else
374 ADD_SIGNOFF=
377 if test -s "$dotest/msg-clean"
378 then
379 cat "$dotest/msg-clean"
381 if test '' != "$ADD_SIGNOFF"
382 then
383 echo "$ADD_SIGNOFF"
385 } >"$dotest/final-commit"
388 case "$resolved$interactive" in
390 # This is used only for interactive view option.
391 git diff-index -p --cached HEAD -- >"$dotest/patch"
393 esac
394 esac
396 resume=
397 if test "$interactive" = t
398 then
399 test -t 0 ||
400 die "cannot be interactive without stdin connected to a terminal."
401 action=again
402 while test "$action" = again
404 echo "Commit Body is:"
405 echo "--------------------------"
406 cat "$dotest/final-commit"
407 echo "--------------------------"
408 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
409 read reply
410 case "$reply" in
411 [yY]*) action=yes ;;
412 [aA]*) action=yes interactive= ;;
413 [nN]*) action=skip ;;
414 [eE]*) git_editor "$dotest/final-commit"
415 action=again ;;
416 [vV]*) action=again
417 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
418 *) action=again ;;
419 esac
420 done
421 else
422 action=yes
424 FIRSTLINE=$(head -1 "$dotest/final-commit")
426 if test $action = skip
427 then
428 go_next
429 continue
432 if test -x "$GIT_DIR"/hooks/applypatch-msg
433 then
434 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
435 stop_here $this
438 printf 'Applying %s\n' "$FIRSTLINE"
440 case "$resolved" in
442 git apply $git_apply_opt $binary --index "$dotest/patch"
443 apply_status=$?
446 # Resolved means the user did all the hard work, and
447 # we do not have to do any patch application. Just
448 # trust what the user has in the index file and the
449 # working tree.
450 resolved=
451 git diff-index --quiet --cached HEAD -- && {
452 echo "No changes - did you forget to use 'git add'?"
453 stop_here_user_resolve $this
455 unmerged=$(git ls-files -u)
456 if test -n "$unmerged"
457 then
458 echo "You still have unmerged paths in your index"
459 echo "did you forget to use 'git add'?"
460 stop_here_user_resolve $this
462 apply_status=0
463 git rerere
465 esac
467 if test $apply_status = 1 && test "$threeway" = t
468 then
469 if (fall_back_3way)
470 then
471 # Applying the patch to an earlier tree and merging the
472 # result may have produced the same tree as ours.
473 git diff-index --quiet --cached HEAD -- && {
474 echo No changes -- Patch already applied.
475 go_next
476 continue
478 # clear apply_status -- we have successfully merged.
479 apply_status=0
482 if test $apply_status != 0
483 then
484 echo Patch failed at $msgnum.
485 stop_here_user_resolve $this
488 if test -x "$GIT_DIR"/hooks/pre-applypatch
489 then
490 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
493 tree=$(git write-tree) &&
494 parent=$(git rev-parse --verify HEAD) &&
495 commit=$(git commit-tree $tree -p $parent <"$dotest/final-commit") &&
496 git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
497 stop_here $this
499 if test -x "$GIT_DIR"/hooks/post-applypatch
500 then
501 "$GIT_DIR"/hooks/post-applypatch
504 go_next
505 done
507 git gc --auto
509 rm -fr "$dotest"